const { contextBridge, ipcRenderer } = require('electron')

function workspace() {
  return call('workspace')
}

function install(version) {
  return call('install', version)
}

function call(...args) {
  return ipcRenderer.invoke(...args)
}

function on(eventName, listener) {
  return ipcRenderer.on(eventName, listener);
}

const clientApi = {
  workspace,
  install,
  call,
  on
};

contextBridge.exposeInMainWorld('clientApi', clientApi);