var net = require('net');

var server = net.createServer();

const clean = str => str.trim().replace(/\s+/g, '').replace('\u0000', '');

module.exports = function (port, workspaceData) {
    server.on('connection', function (sock) {
        sock.on('data', function (data) {
            let reply, utf8Data = data.toString();
            return workspaceData().then((workspace) => {
                if (utf8Data.startsWith('connect')) {
                    const split = utf8Data.split(' ');
                    let index = -1;
                    for (let account in workspace.accounts) {
                        if (clean(workspace.accounts[account].uuid || "-1") === clean(split[4])) {
                            index = account;
                            break;
                        }
                    }
                    sock.write(reply = (`connect account_${index} \x00`))
                }
                else if (utf8Data.startsWith('auth_getGameToken')) {
                    const [, accountIndex] = utf8Data.split(' ');
                    const [, index] = accountIndex.split('_');
                    const target = workspace.accounts[parseInt(index)];
                    // target.apikey = '78cbe7d3a91e39baec22ce30f15543de';
                    sock.write(reply = (`auth_getGameToken ${target?.key.key} \x00`))
                }
                console.log(`received cmd -> '${utf8Data}', replied with -> '${reply}'`)
            });
        });
    });

    server.listen(port, '127.0.0.1', 0, function () {
        console.log('server listening...');
    });
}